<?php
/*
    Plugin Name: WP-Activity
    Plugin URI: http://www.driczone.net/blog/wp-activity
    Description: Display activity stream on your community site
    Author: Dric
    Version: 0.7
    Author URI: http://www.driczone.net
*/

/*  Copyright 2009 Dric  (email : cedric@driczone.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// let's initializing all vars
if ( !isset($_SESSION)) {
		session_start();
	}
$act_version="0.7";
$options = get_option('act_settings');
if ( ! defined( 'WP_CONTENT_URL' ) ) {
	if ( defined( 'WP_SITEURL' ) ) {
    define( 'WP_CONTENT_URL', WP_SITEURL . '/wp-content' );
  }else {
    define( 'WP_CONTENT_URL', get_bloginfo('wpurl') . '/wp-content' );
  }
}
if ( ! defined( 'WP_CONTENT_DIR' ) ) define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ( ! defined( 'WP_PLUGIN_URL' ) ) define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );
if ( ! defined( 'WP_PLUGIN_DIR' ) ) define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins/' );
define('ACT_DIR', dirname(plugin_basename(__FILE__)));
define('ACT_URL', WP_CONTENT_URL . '/plugins/' . ACT_DIR . '/');

//Plugin can be translated, just put the .mo language file in the /lang directory
load_plugin_textdomain('wp-activity', WP_PLUGIN_URL.'/wp-activity/lang/', ACT_DIR . '/lang/');

function act_install()
{
    global $wpdb;
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    $table = $wpdb->prefix."activity";
    $structure = "CREATE TABLE `".$table."` (
      `id` int(9) NOT NULL auto_increment,
      `user_id` bigint(20) NOT NULL,
      `act_type` varchar(20) NOT NULL,
      `act_date` datetime default NULL,
      `act_params` text,
      UNIQUE KEY `id` (`id`),
      KEY `user_id` (`user_id`),
      KEY `act_date` (`act_date`)
      );";
    dbDelta($structure);
    $options['act_prune'] = '500';
    $options['act_feed_display'] = false;
    $options['act_date_format'] = 'yyyy/mm/dd';
    $options['act_date_relative']= true;
    $options['act_connect']= true;
    $options['act_profiles']= true;
    $options['act_posts']= true;
    $options['act_comments']= true;
    $options['act_feed_connect']= false;
    $options['act_feed_profiles']= true;
    $options['act_feed_posts']= true;
    $options['act_feed_comments']= true;
    $options['act_icons']= 'g';
    add_option('act_settings', $options);
    wp_schedule_event(time(), 'daily', 'act_cron_install');
}
register_activation_hook( __FILE__, 'act_install' );

//we add actions to hooks to log their events
add_action('send_headers', 'act_session');
add_action('profile_update', 'act_profile_edit');
add_action('publish_post', 'act_post_add');
add_action('comment_post', 'act_comment_add');
add_action('add_link', 'act_link_add');
 


function act_cron(){
  global $wpdb, $options, $plugin_page;
  $wpdb->query("DELETE FROM ".$wpdb->prefix."activity ORDER BY id ASC LIMIT ".$options['act_prune']);
  
}
add_action('act_cron_install','act_cron');
function act_header(){
  echo '<link type="text/css" rel="stylesheet" href="' . ACT_URL. 'wp-activity.css" />' . "\n";
}
add_action('wp_head', 'act_header');

function act_profile_option(){
  global $wpdb, $user_ID;
  $act_private = get_usermeta($user_ID, 'act_private');
  ?>
  <h3><?php _e('Activity events', 'wp-activity'); ?></h3>
  <table>
    <tr>
		  <th><?php _e('Hide my activity :', 'wp-activity'); ?></th>
		  <td><input type="checkbox" id="act_private" name="act_private" <?php if ($act_private){ echo 'checked="checked"'; }?> value="true" /></td>
    </tr>
  </table>
  <?php
}
add_action('show_user_profile', 'act_profile_option');

function act_profile_update(){
  global $user_ID, $_POST;
  update_usermeta($user_ID,'act_private',isset($_POST['act_private']) ? true : false);
}
add_action('personal_options_update', 'act_profile_update');

function act_session(){
  global $wpdb, $user_ID, $options;
  if ($options['act_connect'] and !get_usermeta($user_ID, 'act_private')){
    if (!$_SESSION['act_logged'] and is_user_logged_in()){
      $time=mysql2date("Y-m-d H:i:s", time());
      $wpdb->query("INSERT INTO ".$wpdb->prefix."activity (user_id, act_type, act_date, act_params) VALUES($user_ID,'CONNECT', '".$time."', '')");
      $url = parse_url(get_option('home'));
      $_SESSION['act_logged']= time();
    }
  }
}

function act_reinit(){
  if ($_SESSION['act_logged']){ unset($_SESSION['act_logged']);}
}
add_action('wp_login', 'act_reinit');
add_action('wp_logout', 'act_reinit');

function act_profile_edit($user){
  global $wpdb, $user_ID, $options;
  if ($options['act_profiles'] and !get_usermeta($user_ID, 'act_private')){
    $time=mysql2date("Y-m-d H:i:s", time());
    $wpdb->query("INSERT INTO ".$wpdb->prefix."activity (user_id, act_type, act_date, act_params) VALUES($user_ID, 'PROFILE_EDIT', '".$time."', $user)");
  }
}

function act_post_add($post){
  global $wpdb, $user_ID, $options;
  if ($options['act_posts'] and !get_usermeta($user_ID, 'act_private')){
    $time=mysql2date("Y-m-d H:i:s", time());
    if ($wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix."activity WHERE act_params=$post AND act_type='POST_ADD'") > 0){
      $type='POST_EDIT';
    }else{
      $type='POST_ADD';
    }
    $wpdb->query("INSERT INTO ".$wpdb->prefix."activity (user_id, act_type, act_date, act_params) VALUES($user_ID, '".$type."', '".$time."', $post)");
  }
}

function act_comment_add($comment){
  global $wpdb, $user_ID, $options;
  if ($options['act_comments'] and !get_usermeta($user_ID, 'act_private')){
    $time=mysql2date("Y-m-d H:i:s", time());
    $wpdb->query("INSERT INTO ".$wpdb->prefix."activity (user_id, act_type, act_date, act_params) VALUES($user_ID,'COMMENT_ADD', '".$time."', $comment)");
  }
}

function act_link_add($link){
  global $wpdb, $user_ID, $options;
  if ($options['act_links'] and !get_usermeta($user_ID, 'act_private')){
    $time=mysql2date("Y-m-d H:i:s", time());
    $wpdb->query("INSERT INTO ".$wpdb->prefix."activity (user_id, act_type, act_date, act_params) VALUES($user_ID, 'LINK_ADD', '".$time."', $link)");
  }
}

function act_last_connect($user=''){
  global $wpdb, $options, $user_ID;
  if (!$user){ $user = $user_ID; }
  if ($options['act_connect'] and !get_usermeta($user_ID, 'act_private')){
    $last_connect = $wpdb->get_var("SELECT MAX(act_date) FROM ".$wpdb->prefix."activity WHERE user_id = '".$user."'");
    echo __("Last logon :", 'wp-activity')." ".nicetime($last_connect);
  }
}

function act_stream($number='30', $title=''){
global $wpdb, $options;
  if ($title == ''){
    $title= __("Recent Activity", 'wp-activity');
  }
  if ($options['act_feed_display']){
    $title .= ' <a href="'.WP_PLUGIN_URL.'/wp-activity/wp-activity-feed.php" title="'.sprintf(__('%s activity RSS Feed', 'wp-activity'),get_bloginfo('name')).'"><img src="'.WP_PLUGIN_URL.'/wp-activity/img/rss.png" alt="" /></a>';
  }
  
  $wp_url = get_bloginfo('wpurl');
  echo '<h2>'.$title.'</h2><ul id="activity">';
  $users = $wpdb->get_results("SELECT ID, display_name, user_nicename FROM $wpdb->users");
  foreach ($users as $user) {
		$users_nicename[$user->ID]=$user->user_nicename;
		$users_display[$user->ID]=$user->display_name;
	}
  $sql  = "SELECT * FROM ".$wpdb->prefix."activity ORDER BY id DESC LIMIT $number";
	if ( $logins = $wpdb->get_results( $sql)){
    foreach ( (array) $logins as $act ){
      $user_nicename = $users_nicename[$act->user_id];
      echo '<li class="login">';
      if ($options['act_icons']== 'g'){
        echo '<img class="activity_icon" alt="" src="'.WP_PLUGIN_URL.'/wp-activity/img/'.$act->act_type.'.png" />';
      }elseif ($options['act_icons']== 'a'){
        if ($act->act_type == 'CONNECT' or $act->act_type == 'PROFILE_EDIT'){
          echo get_avatar( $act->user_id, '16'); ;
        }else{
          echo '<img class="activity_icon" alt="" src="'.WP_PLUGIN_URL.'/wp-activity/img/'.$act->act_type.'.png" />';
        }
      }
      switch ($act->act_type){
        case 'CONNECT':
          echo '<a href="'.$wp_url.'/author/'.$user_nicename.'" title="'.__('View Profile', 'wp-activity').'">'.$users_display[$act->user_id].'</a> '.__('has logged.', 'wp-activity');
          break;
        case 'COMMENT_ADD':
          $act_comment=get_comment($act->act_params);
          $act_post=get_post($act_comment->comment_post_ID);
          echo '<a href="'.$wp_url.'/author/'.$user_nicename.'" title="'.__('View Profile', 'wp-activity').'">'.$act_comment->comment_author.'</a> '.__('commented', 'wp-activity').' <a href="'.$act_post->post_name.'#comment-'.$act_comment->comment_ID.'">'.$act_post->post_title.'</a>';
          break;
        case 'POST_ADD':
          $act_post=get_post($act->act_params);
          echo '<a href="'.$wp_url.'/author/'.$user_nicename.'" title="'.__('View Profile', 'wp-activity').'">'.$users_display[$act_post->post_author].'</a> '.__('published', 'wp-activity').' <a href="'.$act_post->post_name.'">'.$act_post->post_title.'</a>';
          break;
        case 'POST_EDIT':
          $act_post=get_post($act->act_params);
          echo '<a href="'.$wp_url.'/author/'.$user_nicename.'" title="'.__('View Profile', 'wp-activity').'">'.$users_display[$act_post->post_author].'</a> '.__('edited', 'wp-activity').' <a href="'.$act_post->post_name.'">'.$act_post->post_title.'</a>';
          break;
        case 'PROFILE_EDIT':
          echo '<a href="'.$wp_url.'/author/'.$user_nicename.'" title="'.__('View Profile', 'wp-activity').'">'.$users_display[$act->user_id].'</a> '.__('has updated his profile.', 'wp-activity');
          break;
        case 'LINK_ADD':
          $link = get_bookmark($act->act_params);
          if ($link->link_visible == 'Y'){
            echo '<a href="'.$wp_url.'/author/'.$user_nicename.'" title="'.__('View Profile', 'wp-activity').'">'.$users_display[$act->user_id].'</a> '.__('has added a link to', 'wp-activity').' <a href="'.$link->link_url.'" title="'.$link->link_description.'" target="'.$link->link_target.'">'.$link->link_name.'</a>.';
          }
          break;
        default:
          break;
      }
      echo '<span class="activity_date">'.nicetime($act->act_date).'</span>';
      echo '</li>';
    }
  }
  echo '</ul>';
}

function nicetime($posted_date, $admin=false) {
    $act_opt=get_option('act_settings');
    $date_relative = $act_opt['act_date_relative'];
    $date_format = $act_opt['act_date_format'];
    $in_seconds = strtotime($posted_date);   
    $relative_date = '';
    $diff = time()-$in_seconds;
    $months = floor($diff/2592000);
    $diff -= $months*2419200;
    $weeks = floor($diff/604800);
    $diff -= $weeks*604800;
    $days = floor($diff/86400);
    $diff -= $days*86400;
    $hours = floor($diff/3600);
    $diff -= $hours*3600;
    $minutes = floor($diff/60);
    $diff -= $minutes*60;
    $seconds = $diff;
    if ($months>0 or !$date_relative or $admin) {
        // over a month old, just show date
        if (!$date_relative or $admin){
          $h = substr($posted_date,10);
        } else {
          $h = '';
        }
        switch ($date_format){
          case 'dd/mm/yyyy':
            return substr($posted_date,8,2).'/'.substr($posted_date,5,2).'/'.substr($posted_date,0,4).$h;
            break;
          case 'mm/dd/yyyy':
            return substr($posted_date,5,2).'/'.substr($posted_date,8,2).'/'.substr($posted_date,0,4).$h;
            break;
          case 'yyyy/mm/dd':
          default:
            return substr($posted_date,0,4).'/'.substr($posted_date,5,2).'/'.substr($posted_date,8,2).$h;
            break;
        }
    } else {
        if ($weeks>0) {
            // weeks and days
            $relative_date .= ($relative_date?', ':'').$weeks.' '.($weeks>1? __('weeks', 'wp-activity'):__('week', 'wp-activity'));
            $relative_date .= $days>0?($relative_date?', ':'').$days.' '.($days>1? __('days', 'wp-activity'):__('day', 'wp-activity')):'';
        } elseif ($days>0) {
            // days and hours
            $relative_date .= ($relative_date?', ':'').$days.' '.($days>1? __('days', 'wp-activity'):__('day', 'wp-activity'));
            $relative_date .= $hours>0?($relative_date?', ':'').$hours.' '.($hours>1? __('hours', 'wp-activity'):__('hour', 'wp-activity')):'';
        } elseif ($hours>0) {
            // hours and minutes
            $relative_date .= ($relative_date?', ':'').$hours.' '.($hours>1? __('hours', 'wp-activity'):__('hour', 'wp-activity'));
            $relative_date .= $minutes>0?($relative_date?', ':'').$minutes.' '.($minutes>1? __('minutes', 'wp-activity'):__('minute', 'wp-activity')):'';
        } elseif ($minutes>0) {
            // minutes only
            $relative_date .= ($relative_date?', ':'').$minutes.' '.($minutes>1? __('minutes', 'wp-activity'):__('minute', 'wp-activity'));
        } else {
            // seconds only
            $relative_date .= ($relative_date?', ':'').$seconds.' '.($seconds>1? __('seconds', 'wp-activity'):__('second', 'wp-activity'));
        }
    }
    // show relative date and add proper verbiage
    return sprintf(__('%s ago', 'wp-activity'), $relative_date);
}

function act_admin_menu(){
  $plugin_page = add_options_page('WP-Activity', 'WP-Activity', 8, 'wp-activity', 'act_admin');
  add_action( 'admin_head-'. $plugin_page, 'act_header' );
}
add_action('admin_menu', 'act_admin_menu');

function act_admin(){
  global $wpdb, $act_version;
  
  $count = $wpdb->get_var("SELECT count(ID) FROM ".$wpdb->prefix."activity");
  ?>
    <div class="wrap">
  	<h2>WP-Activity</h2>
    <div id="activity-rows">(<?php echo $count.' '.__('rows in db','wp-activity') ?>)</div>
  	<a href="admin.php?page=wp-activity&screen=activity"><?php _e("Recent Activity", 'wp-activity') ?></a> - <a href="admin.php?page=wp-activity&screen=manage"><?php _e("Manage", 'wp-activity') ?></a>
  <?php
  if ($_GET['screen'] == 'manage'){
  if ( isset($_POST['act_action'] ) ){
    switch ($_POST['act_action']){
      case "clean":
        $sql="DELETE FROM ".$wpdb->prefix."activity";
		    if ( $results = $wpdb->query( $sql ) ){
		      echo '<div id="message" class="updated fade"><p><strong>'.__('Activity logs deleted.', 'wp-activity').'</strong></div>';
		    }
        break;
      default:
          $options['act_connect']=$_POST['act_connect'];
          $options['act_profiles']=$_POST['act_profiles'];
          $options['act_posts']=$_POST['act_posts'];
          $options['act_comments']=$_POST['act_comments'];
          $options['act_links']=$_POST['act_links'];
          $options['act_feed_connect']=$_POST['act_feed_connect'];
          $options['act_feed_profiles']=$_POST['act_feed_profiles'];
          $options['act_feed_posts']=$_POST['act_feed_posts'];
          $options['act_feed_comments']=$_POST['act_feed_comments'];
          $options['act_feed_links']=$_POST['act_feed_links'];
          $options['act_feed_display']=$_POST['act_feed_display'];
          $options['act_prune']=$_POST['act_prune'];
          $options['act_date_format']=$_POST['act_date_format'];
          $options['act_date_relative']=$_POST['act_date_relative'];
          $options['act_icons']=$_POST['act_icons'];
          update_option('act_settings', $options);
        break;
    }
	}
  $act_opt=get_option('act_settings');
  extract($act_opt);
  ?>
  	<form action='' method='post'>
  	<table class="form-table">
  	  <tr><th><h3><?php _e('Date format : ','wp-activity') ?></h3></th></tr>
      <tr valign="top">
        <th scope="row"><?php _e('Date format : ','wp-activity') ?></th>
  	    <td><select name="act_date_format">
        <option <?php if($act_date_format == 'yyyy/mm/dd') {echo"selected='selected' ";} ?>value ="yyyy/mm/dd">yyyy/mm/dd</option>
        <option <?php if($act_date_format == 'mm/dd/yyyy') {echo"selected='selected' ";} ?>value ="mm/dd/yyyy">mm/dd/yyyy</option>
        <option <?php if($act_date_format == 'dd/mm/yyyy') {echo"selected='selected' ";} ?>value ="dd/mm/yyyy">dd/mm/yyyy</option>
      </select><br /><?php _e('For events that are more than a month old only, or if you dont use relative dates.','wp-activity') ?></td>
  	  </tr><tr>
  	    <th><?php _e('Use relative dates : ', 'wp-activity') ?></th>
  	    <td><input type="checkbox" <?php if($act_date_relative){echo 'checked="checked"';} ?> name="act_date_relative" /></td>
  	  </tr><tr>
  	  <tr><th><h3><?php _e('Display options','wp-activity') ?></h3></th></tr>
  	  <tr>
        <th><?php _e('Display icons : ', 'wp-activity') ?></th>
        <td><input type="radio" <?php if($act_icons=="g"){echo 'checked="checked"';} ?> name="act_icons" value="g" /> <?php _e('Generic icons ', 'wp-activity') ?></td>
      </tr>
  	  <tr><td></td><td><input type="radio" <?php if($act_icons=="a"){echo 'checked="checked"';} ?> name="act_icons" value="a" /> <?php _e('Gravatars for profile edit and connect events icons', 'wp-activity') ?></td></tr>
  	  <tr><td></td><td><input type="radio" <?php if($act_icons=="n"){echo 'checked="checked"';} ?> name="act_icons" value="n" /> <?php _e('No icons ', 'wp-activity') ?></td></tr>
      <th><h3><?php _e('Events logging and feeding', 'wp-activity') ?></h3></th>
      </tr><tr>
      <th><?php _e('Rows limit in database : ', 'wp-activity') ?></th><td><input type="text" name="act_prune" value="<?php echo $act_prune ?>" /></td>
  	  </tr><tr>
      <th><?php _e('Display activity RSS feed : ', 'wp-activity') ?></th><td><input type="checkbox" <?php if($act_feed_display){echo 'checked="checked"';} ?> name="act_feed_display" /></td>
  	  </tr><tr>
      <th></th><th><?php _e('Log in database', 'wp-activity') ?></th><th><?php _e('Display in feed', 'wp-activity') ?></th>
      </tr><tr>
        <th><?php _e('Login events : ', 'wp-activity') ?></th>
        <td><input type="checkbox" <?php if($act_connect){echo 'checked="checked"';} ?> name="act_connect" /></td>
        <td><input type="checkbox" <?php if($act_feed_connect){echo 'checked="checked"';} ?> name="act_feed_connect" /></td>
      </tr><tr>
        <th><?php _e('Profile update events : ', 'wp-activity') ?></th>
        <td><input type="checkbox" <?php if($act_profiles){echo 'checked="checked"';} ?> name="act_profiles" /></td>
        <td><input type="checkbox" <?php if($act_feed_profiles){echo 'checked="checked"';} ?> name="act_feed_profiles" /></td>
      </tr><tr>
        <th><?php _e('Post creation/update events : ', 'wp-activity') ?></th>
        <td><input type="checkbox" <?php if($act_posts){echo 'checked="checked"';} ?> name="act_posts" /></td>
        <td><input type="checkbox" <?php if($act_feed_posts){echo 'checked="checked"';} ?> name="act_feed_posts" /></td>
      </tr><tr>
        <th><?php _e('New comment events : ', 'wp-activity') ?></th>
        <td><input type="checkbox" <?php if($act_comments){echo 'checked="checked"';} ?> name="act_comments" /></td>
        <td><input type="checkbox" <?php if($act_feed_comments){echo 'checked="checked"';} ?> name="act_feed_comments" /></td>
      </tr><tr>
        <th><?php _e('New link events : ', 'wp-activity') ?></th>
        <td><input type="checkbox" <?php if($act_links){echo 'checked="checked"';} ?> name="act_links" /></td>
        <td><input type="checkbox" <?php if($act_feed_links){echo 'checked="checked"';} ?> name="act_feed_links" /></td>
      </tr>
      </table>
      <br />
      <h3><?php _e('Update/clean tables', 'wp-activity') ?></h3>
      <p><?php _e('Warning : cleaning activity table erase all activity logs.', 'wp-activity') ?></p>
      <select name="act_action">
        <option value ="update"><?php _e('Update settings', 'wp-activity') ?></option>
  			<option value ="clean"><?php _e('Clean activity table', 'wp-activity') ?></option>        
      </select>
      <input type='submit' class='button-primary' name='submit' value='<?php _e('Submit', 'wp-activity') ?>' />
    </form>
    <?php 
    }else{ 
      if ($_GET['act_page']){
        $page = $_GET['act_page'];
      }else{
        $page = 1;
      }
    ?>
    <h3><?php _e("Recent Activity", 'wp-activity'); ?></h3>
    <?php
    $start = ($page - 1)*50;
    $nbpages = floor($count/50);
    if (($count % 50)> 0){
      $nbpages++; 
    }
    echo __("Page", 'wp-activity').' '.$page.'/'.$nbpages; 
    ?>
    <table id="activity-admin">
        <tr><th colspan="2" align="left">
    <?php
    if ($page >1){
      echo '<a href="admin.php?page=wp-activity&screen=activity&act_page='.($page-1).'">'.__("&laquo; Previous Page").'</a>';
    }
    ?>
      </th><th colspan="2" align="right">
    <?php
    if ($start+50 < $count){
      echo '<a href="admin.php?page=wp-activity&screen=activity&act_page='.($page+1).'">'.__("Next Page &raquo;").'</a>';
    }
    ?>     
      </th></tr>
      <tr>
        <th><?php _e("Date", 'wp-activity'); ?></th>
        <th><?php _e("User", 'wp-activity'); ?></th>
        <th><?php _e("Event Type", 'wp-activity'); ?></th>
        <th><?php _e("Data", 'wp-activity'); ?></th>
      </tr>
<?php
  $users = $wpdb->get_results("SELECT ID, display_name FROM $wpdb->users");
  foreach ($users as $user) {
		$users_display[$user->ID]=$user->display_name;
	}
  $sql  = "SELECT * FROM ".$wpdb->prefix."activity ORDER BY id DESC LIMIT ".$start.",50";
	if ( $logins = $wpdb->get_results( $sql)){
    foreach ( (array) $logins as $act ){
      $user_display = $users_display[$act->user_id];
      echo '<tr><td>'.nicetime($act->act_date, true).'</td>';
      switch ($act->act_type){
        case 'CONNECT':
          echo '<td>'.$user_display.'</td><td>'.$act->act_type.'</td><td></td>';
          break;
        case 'COMMENT_ADD':
          $act_comment=get_comment($act->act_params);
          $act_post=get_post($act_comment->comment_post_ID);
          echo '<td>'.$user_display.'</td><td>'.$act->act_type.'</td><td><a href="'.$act_post->post_name.'#comment-'.$act_comment->comment_ID.'">'.$act_post->post_title.'</a></td>';
          break;
        case 'POST_ADD':
        case 'POST_EDIT':
          $act_post=get_post($act->act_params);
          echo '<td>'.$user_display.'</td><td>'.$act->act_type.'</td><td><a href="'.$act_post->post_name.'">'.$act_post->post_title.'</a></td>';
          break;
        case 'PROFILE_EDIT':
          echo '<td>'.$user_display.'</td><td>'.$act->act_type.'</td><td></td>';
          break;
        case 'LINK_ADD':
          $link = get_bookmark($act->act_params);
          if ($link->link_visible == 'Y'){
            echo '<td>'.$user_display.'</td><td>'.$act->act_type.'</td><td><a href="'.$link->link_url.'" title="'.$link->link_description.'" target="'.$link->link_target.'">'.$link->link_name.'</a></td>';
          }
          break;
        default:
          break;
      }
      echo '</tr>';
    }
  } 
    ?>
      <tr><th colspan="2" align="left">
    <?php
    if ($page >1){
      echo '<a href="admin.php?page=wp-activity&screen=activity&act_page='.($page-1).'">'.__("&laquo; Previous Page").'</a>';
    }
    ?>
      </th><th colspan="2" align="right">
    <?php
    if ($start+50 < $count){
      echo '<a href="admin.php?page=wp-activity&screen=activity&act_page='.($page+1).'">'.__("Next Page &raquo;").'</a>';
    }
    ?>     
      </th></tr>
    </table>
  <?php } ?>
  <br />
    <h4><?php echo sprintf(__('WP-Activity is a plugin made in France by <a href="http://www.driczone.net">Dric</a>. Version <strong>%s</strong>.', 'wp-activity'), $act_version) ?></h4>
  </div>
  <?php
}

add_action( 'widgets_init', 'WPActivity_load_widgets' );

function WPActivity_load_widgets() {
	register_widget( 'WpActivity_Widget' );
}
class WpActivity_Widget extends WP_Widget {

	function WpActivity_Widget() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'wp-activity', 'description' => __('Display a stream of registered users events', 'wp-activity') );

		/* Widget control settings. */
		$control_ops = array( 'height' => 350, 'id_base' => 'wp-activity' );

		/* Create the widget. */
		$this->WP_Widget( 'wp-activity', __('Wp-Activity Widget', 'wp-activity'), $widget_ops, $control_ops );
	}

	function widget( $args, $instance ) {
		extract( $args );
		$title = apply_filters('widget_title', $instance['title'] );
		$number = $instance['number'];

		echo $before_widget;
		if ( $title )
			$title =  $before_title . $title . $after_title;
  act_stream($number, $title);
	echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['number'] = $new_instance['number'];
		return $instance;
	}

	function form( $instance ) {

		$defaults = array( 'title' => __('Recent Activity', 'wp-activity'), 'number' => '30');
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>

		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title :', 'wp-activity'); ?></label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" style="width:100%;" />
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'number' ); ?>"><?php _e('Events number :', 'wp-activity'); ?></label>
			<input id="<?php echo $this->get_field_id( 'number' ); ?>" name="<?php echo $this->get_field_name( 'number' ); ?>" value="<?php echo $instance['number']; ?>" style="width:100%;" />
		</p>

	<?php
	}
}

?>
